# -*- coding: utf-8 -*-

from rest_framework import viewsets
from rest_framework.decorators import action

from thx.api.views import ThuxViewMixin
from thx.role.core.views import ThuxRoleViewSetMixin
from . import serializers
from ... import models


# CURRENCY
class CurrencyViewSet(ThuxRoleViewSetMixin, ThuxViewMixin, viewsets.ModelViewSet):
    queryset = models.Currency.objects.all()
    serializer_class = serializers.CurrencySerializer

    @action(methods=['patch'], detail=True)
    def enable(self, request, **filters):
        return super().partial_update(request)

    @action(methods=['patch'], detail=True)
    def disable(self, request, **filters):
        return super().partial_update(request)
